Index: trunk/source/persistency/ascii/include/G4tgrMaterialSimple.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrMaterialSimple.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrMaterialSimple.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrMaterialSimple.hh,v 1.2 2008/12/18 12:58:46 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrMessenger.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrMessenger.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrMessenger.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrMessenger.hh,v 1.1 2008/10/23 14:43:43 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrParameterMgr.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrParameterMgr.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrParameterMgr.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrParameterMgr.hh,v 1.2 2008/12/18 12:58:48 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrPlace.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrPlace.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrPlace.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrPlace.hh,v 1.4 2008/12/18 12:58:50 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrPlaceDivRep.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrPlaceDivRep.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrPlaceDivRep.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrPlaceDivRep.hh,v 1.5 2008/12/18 12:58:52 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrPlaceParameterisation.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrPlaceParameterisation.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrPlaceParameterisation.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrPlaceParameterisation.hh,v 1.7 2008/12/18 12:58:54 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrPlaceSimple.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrPlaceSimple.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrPlaceSimple.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrPlaceSimple.hh,v 1.5 2008/12/18 12:58:56 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrRotationMatrix.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrRotationMatrix.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrRotationMatrix.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrRotationMatrix.hh,v 1.5 2008/12/18 12:58:58 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrRotationMatrixFactory.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrRotationMatrixFactory.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrRotationMatrixFactory.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrRotationMatrixFactory.hh,v 1.2 2008/12/18 12:59:00 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrSolid.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrSolid.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrSolid.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrSolid.hh,v 1.2 2008/12/18 12:59:02 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrSolidBoolean.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrSolidBoolean.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrSolidBoolean.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrSolidBoolean.hh,v 1.2 2008/12/18 12:59:04 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrUtils.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrUtils.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrUtils.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrUtils.hh,v 1.6 2008/12/18 12:59:06 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrVolume.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrVolume.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrVolume.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4tgrVolume.hh,v 1.7 2008/12/18 12:59:08 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4tgrVolume.hh,v 1.10 2009/11/23 11:38:54 arce Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -65,4 +65,5 @@
     G4tgrVolume();
     G4tgrVolume( const std::vector<G4String>& wl );
+    G4tgrVolume( const G4tgrVolume& vol );
     virtual ~G4tgrVolume();
 
@@ -94,5 +95,7 @@
     const std::vector<G4tgrPlace*> GetPlacements() const {return thePlacements;}
     G4bool GetVisibility() const {return theVisibility;}
-    const G4double* GetColour() const {return theRGBColour;}
+    G4double* GetColour() const {return theRGBColour;}
+    G4double* GetRGBColour() const {return theRGBColour;}
+
     G4bool GetCheckOverlaps() const {return theCheckOverlaps;}
 
Index: trunk/source/persistency/ascii/include/G4tgrVolumeAssembly.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrVolumeAssembly.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrVolumeAssembly.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrVolumeAssembly.hh,v 1.5 2008/12/18 12:59:10 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrVolumeDivision.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrVolumeDivision.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrVolumeDivision.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrVolumeDivision.hh,v 1.5 2008/12/18 12:59:12 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/include/G4tgrVolumeMgr.hh
===================================================================
--- trunk/source/persistency/ascii/include/G4tgrVolumeMgr.hh	(revision 1227)
+++ trunk/source/persistency/ascii/include/G4tgrVolumeMgr.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrVolumeMgr.hh,v 1.5 2008/12/18 12:59:14 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbDetectorBuilder.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbDetectorBuilder.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbDetectorBuilder.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbDetectorBuilder.cc,v 1.4 2008/12/18 12:59:16 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbDetectorConstruction.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbDetectorConstruction.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbDetectorConstruction.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbDetectorConstruction.cc,v 1.4 2008/12/18 12:59:18 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbElement.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbElement.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbElement.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbElement.cc,v 1.4 2008/12/18 12:59:20 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbGeometryDumper.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbGeometryDumper.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbGeometryDumper.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4tgbGeometryDumper.cc,v 1.11 2008/12/18 12:59:22 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4tgbGeometryDumper.cc,v 1.12 2009/11/19 13:29:04 arce Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -642,8 +642,8 @@
 
   } else if (solidType == "SUBTRACTIONSOLID")  {
-    DumpBooleanVolume( "SUBS", solid );
+    DumpBooleanVolume( "SUBTRACTION", solid );
 
   } else if (solidType == "INTERSECTIONSOLID") {
-    DumpBooleanVolume( "INTERS", solid );
+    DumpBooleanVolume( "INTERSECTION", solid );
 
   } else if (solidType == "REFLECTEDSOLID") {
Index: trunk/source/persistency/ascii/src/G4tgbIsotope.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbIsotope.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbIsotope.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbIsotope.cc,v 1.4 2008/12/18 12:59:24 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbMaterial.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbMaterial.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbMaterial.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbMaterial.cc,v 1.2 2008/12/18 12:59:26 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbMaterialMgr.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbMaterialMgr.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbMaterialMgr.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbMaterialMgr.cc,v 1.5 2008/12/18 12:59:28 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbMaterialMixture.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbMaterialMixture.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbMaterialMixture.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbMaterialMixture.cc,v 1.1 2008/10/23 14:43:43 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbMaterialMixtureByNoAtoms.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbMaterialMixtureByNoAtoms.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbMaterialMixtureByNoAtoms.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbMaterialMixtureByNoAtoms.cc,v 1.6 2008/12/18 12:59:30 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbMaterialMixtureByVolume.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbMaterialMixtureByVolume.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbMaterialMixtureByVolume.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbMaterialMixtureByVolume.cc,v 1.8 2008/12/18 12:59:32 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbMaterialMixtureByWeight.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbMaterialMixtureByWeight.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbMaterialMixtureByWeight.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbMaterialMixtureByWeight.cc,v 1.4 2008/12/18 12:59:34 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbMaterialSimple.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbMaterialSimple.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbMaterialSimple.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbMaterialSimple.cc,v 1.5 2008/12/18 12:59:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbPlaceParamCircle.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbPlaceParamCircle.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbPlaceParamCircle.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbPlaceParamCircle.cc,v 1.5 2008/12/03 16:16:01 arce Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbPlaceParamLinear.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbPlaceParamLinear.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbPlaceParamLinear.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbPlaceParamLinear.cc,v 1.5 2008/12/03 16:16:01 arce Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbPlaceParamSquare.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbPlaceParamSquare.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbPlaceParamSquare.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbPlaceParamSquare.cc,v 1.6 2008/12/03 16:16:01 arce Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbPlaceParameterisation.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbPlaceParameterisation.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbPlaceParameterisation.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbPlaceParameterisation.cc,v 1.4 2008/11/21 15:37:18 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4tgbPlaceParameterisation
Index: trunk/source/persistency/ascii/src/G4tgbRotationMatrix.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbRotationMatrix.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbRotationMatrix.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbRotationMatrix.cc,v 1.8 2008/12/18 12:59:38 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbRotationMatrixMgr.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbRotationMatrixMgr.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbRotationMatrixMgr.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbRotationMatrixMgr.cc,v 1.2 2008/12/18 12:59:40 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgbVolume.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbVolume.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbVolume.cc	(revision 1228)
@@ -92,6 +92,10 @@
 #include "G4BREPSolidPolyhedra.hh"
 #include "G4BREPSolidOpenPCone.hh"
+#include "G4TessellatedSolid.hh"
+#include "G4TriangularFacet.hh"
+#include "G4QuadrangularFacet.hh"
+#include "G4ExtrudedSolid.hh"
+
 #include "G4VisExtent.hh"
-
 #include "G4Material.hh"
 #include "G4RotationMatrix.hh"
@@ -633,4 +637,111 @@
                                       &((*z_p)[0]), &((*rmin_p)[0]),
                                       &((*rmax_p)[0]));
+  }
+  else if( stype == "TESSELLATED" )
+  {
+    G4int nFacets = G4int(solParam[0]);
+    G4int jj = 0;
+    solid = new G4TessellatedSolid(sname);
+    G4TessellatedSolid* solidTS = (G4TessellatedSolid*)(solid);
+    G4VFacet* facet=0;
+    
+    for( G4int ii = 0; ii < nFacets; ii++){
+      G4int nPoints = G4int(solParam[jj+1]);
+      if( G4int(solParam.size()) < jj + nPoints*3 + 2 ) {
+	G4String Err1 = "Too small number of parameters in tesselated solid, it should be at least "  + G4UIcommand::ConvertToString(jj + nPoints*3 + 2 );
+	G4String Err2 = " facet number " + G4UIcommand::ConvertToString(ii);
+	G4String Err3 = " number of parameters is " + G4UIcommand::ConvertToString(G4int(solParam.size()));
+	G4String ErrMessage = Err1 + Err2 + Err3 + " !";
+	G4Exception("G4tgbVolume::FindOrConstructG4Solid()",
+		    "InvalidSetup", FatalException, ErrMessage);
+      }
+      
+      if( nPoints == 3 ) 
+      {
+	G4ThreeVector pt0(solParam[jj+2],solParam[jj+3],solParam[jj+4]);
+	G4ThreeVector vt1(solParam[jj+5],solParam[jj+6],solParam[jj+7]);
+	G4ThreeVector vt2(solParam[jj+8],solParam[jj+9],solParam[jj+10]);
+	G4FacetVertexType vertexType = ABSOLUTE;
+	if( solParam[jj+11] == 0 ) 
+	{
+	  vertexType = ABSOLUTE;
+	} 
+	else if( solParam[jj+11] == 0 ) 
+	{
+	  vertexType = RELATIVE;
+	} 
+	else 
+	{
+	  G4String Err1 = "Wrong number of vertex type in tesselated solid, it should be 0 =ABSOLUTE) or 1 (=RELATIVE)";
+	  G4String Err2 = " facet number " + G4UIcommand::ConvertToString(G4int(ii));
+	  G4String Err3 = " vertex type is " + G4UIcommand::ConvertToString(solParam[jj+11]);
+	  G4String ErrMessage = Err1 + Err2 + Err3 + " !";
+	  G4Exception("G4tgbVolume::FindOrConstructG4Solid()",
+		      "InvalidSetup", FatalException, ErrMessage);
+	}
+	facet = new G4TriangularFacet( pt0, vt1, vt2, vertexType );
+      } 
+      else if( nPoints == 4 ) 
+      {
+	G4ThreeVector pt0(solParam[jj+2],solParam[jj+3],solParam[jj+4]);
+	G4ThreeVector vt1(solParam[jj+5],solParam[jj+6],solParam[jj+7]);
+	G4ThreeVector vt2(solParam[jj+8],solParam[jj+9],solParam[jj+10]);
+	G4ThreeVector vt3(solParam[jj+11],solParam[jj+12],solParam[jj+13]);
+	G4FacetVertexType vertexType = ABSOLUTE;
+	if( solParam[jj+14] == 0 ) 
+	{
+	  vertexType = ABSOLUTE;
+	}
+	else if( solParam[jj+14] == 0 ) 
+	{
+	  vertexType = RELATIVE;
+	} 
+	else 
+	{
+	  G4String Err1 = "Wrong number of vertex type in tesselated solid, it should be 0 =ABSOLUTE) or 1 (=RELATIVE)";
+	  G4String Err2 = " facet number " + G4UIcommand::ConvertToString(G4int(ii));
+	  G4String Err3 = " vertex type is " + G4UIcommand::ConvertToString(solParam[jj+14]);
+	  G4String ErrMessage = Err1 + Err2 + Err3 + " !";
+	  G4Exception("G4tgbVolume::FindOrConstructG4Solid()",
+		      "InvalidSetup", FatalException, ErrMessage);
+	}
+	facet = new G4QuadrangularFacet( pt0, vt1, vt2, vt3, vertexType );
+      } 
+      else 
+      {
+	G4String Err1 = "Wrong number of points in tesselated solid, it should be 3 or 4";
+	G4String Err2 = " facet number " + G4UIcommand::ConvertToString(G4int(ii));
+	G4String Err3 = " number of points is " + G4UIcommand::ConvertToString(G4int(nPoints));
+	G4String ErrMessage = Err1 + Err2 + Err3 + " !";
+	G4Exception("G4tgbVolume::FindOrConstructG4Solid()",
+		    "InvalidSetup", FatalException, ErrMessage);
+      }
+      
+      solidTS->AddFacet( facet );
+      jj += nPoints*3 + 2;
+    }
+    
+  }  
+  else if( stype == "EXTRUDED" ) 
+  {
+    std::vector<G4TwoVector> polygonList;
+    std::vector<G4ExtrudedSolid::ZSection> zsectionList;
+    G4int nPolygons = G4int(solParam[0]);
+    G4int ii = 1;
+    G4int nMax = nPolygons*2+1;
+    for( ;ii < nMax; ii+=2 )
+    {
+      polygonList.push_back( G4TwoVector(solParam[ii],solParam[ii+1]) );
+    }
+    G4int nZSections = G4int(solParam[ii]);
+    nMax = nPolygons*2 + nZSections*4 + 2; 
+    ii++;
+    for( ; ii < nMax; ii+=4 )
+    {
+      G4TwoVector offset(solParam[ii+1],solParam[ii+2]);
+      zsectionList.push_back( G4ExtrudedSolid::ZSection(solParam[ii],offset,solParam[ii+3]) );
+    }
+    solid = new G4ExtrudedSolid( sname, polygonList, zsectionList );
+    
   }
   else if( stype.substr(0,7) == "Boolean" )
Index: trunk/source/persistency/ascii/src/G4tgbVolumeMgr.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgbVolumeMgr.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgbVolumeMgr.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgbVolumeMgr.cc,v 1.5 2008/12/18 12:59:44 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrElement.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrElement.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrElement.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrElement.cc,v 1.1 2008/10/23 14:43:43 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrElementFromIsotopes.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrElementFromIsotopes.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrElementFromIsotopes.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrElementFromIsotopes.cc,v 1.5 2008/12/18 12:59:46 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrElementSimple.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrElementSimple.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrElementSimple.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrElementSimple.cc,v 1.5 2008/12/18 12:59:48 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrEvaluator.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrEvaluator.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrEvaluator.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrEvaluator.cc,v 1.1 2008/10/23 14:43:43 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrFileIn.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrFileIn.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrFileIn.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrFileIn.cc,v 1.9 2008/12/18 12:59:50 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrFileReader.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrFileReader.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrFileReader.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrFileReader.cc,v 1.4 2008/11/12 08:44:07 arce Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrIsotope.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrIsotope.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrIsotope.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrIsotope.cc,v 1.5 2008/12/18 12:59:52 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrMaterial.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrMaterial.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrMaterial.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrMaterial.cc,v 1.3 2008/11/21 15:37:18 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrMaterialFactory.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrMaterialFactory.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrMaterialFactory.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrMaterialFactory.cc,v 1.4 2008/12/18 12:59:54 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrMaterialMixture.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrMaterialMixture.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrMaterialMixture.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrMaterialMixture.cc,v 1.7 2008/12/18 12:59:56 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrMaterialSimple.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrMaterialSimple.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrMaterialSimple.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrMaterialSimple.cc,v 1.7 2008/12/18 12:59:58 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrMessenger.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrMessenger.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrMessenger.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrMessenger.cc,v 1.1 2008/10/23 14:43:43 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrParameterMgr.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrParameterMgr.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrParameterMgr.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrParameterMgr.cc,v 1.6 2008/12/18 13:00:00 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrPlace.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrPlace.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrPlace.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrPlace.cc,v 1.3 2008/11/03 17:04:41 arce Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrPlaceDivRep.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrPlaceDivRep.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrPlaceDivRep.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrPlaceDivRep.cc,v 1.4 2008/11/21 15:37:18 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrPlaceParameterisation.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrPlaceParameterisation.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrPlaceParameterisation.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrPlaceParameterisation.cc,v 1.6 2008/12/18 13:00:02 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrPlaceSimple.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrPlaceSimple.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrPlaceSimple.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrPlaceSimple.cc,v 1.5 2008/12/18 13:00:04 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrRotationMatrix.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrRotationMatrix.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrRotationMatrix.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrRotationMatrix.cc,v 1.5 2008/12/18 13:00:06 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrRotationMatrixFactory.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrRotationMatrixFactory.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrRotationMatrixFactory.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrRotationMatrixFactory.cc,v 1.2 2008/12/18 13:00:08 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrSolid.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrSolid.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrSolid.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrSolid.cc,v 1.6 2008/12/18 13:00:10 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
